<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
//use Illuminate\Support\Facades\Request;
use DB;
use App\Http\Controllers\SharedController;

class CategoryController extends Controller
{

    protected $SharedController;

    public function __construct(SharedController $SharedController)
    {
        $this->SharedController = $SharedController;
    }


    /**
     * Handle the incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function __invoke(Request $request)
    {
        //
    }

    public function wLogs($data)
    {
        $logPath = "logs.txt";
        $mode = (!file_exists($logPath)) ? 'w':'a';
        $logfile = fopen($logPath, $mode);
        fwrite($logfile, "\r\n". $data);
        fclose($logfile);
    }

    public function getCategories($parentId)
    {
        $where = ($parentId != -1) ? " and id_parent = " . $parentId : "";

        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_category where statut=1 " . $where;

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAdminCategories($niveauMax)
    {
        /*$sql = "select 
                    t1.id, t1.nom, t1.titre,  t1.id_parent, t2.nom as parent, t1.description, t1.mot_cle, t1.statut as Active 
                from t_category t1
                    left join t_category t2 on t1.id_parent = t2.id 
                where t1.statut=1 order by t1.nom asc";*/

        $sql = "WITH RECURSIVE t_category_path (id, nom, nomsource, id_parent, parent, description, mot_cle, titre, Active) AS
				(
				  SELECT c1.id, c1.nom, c1.nom as nomsource, c1.id_parent, c2.nom as parent, c1.description, c1.mot_cle, c1.titre, c1.statut as Active
					FROM t_category c1
						left join t_category c2 on c1.id_parent = c2.id
					WHERE (c1.id_parent IS NULL or c1.id_parent = 0) and c1.statut = 1
				  UNION ALL
				  SELECT c.id, CONCAT(cp.nom, ' > ', c.nom), c.nom as nomsource, c.id_parent, cp.nom as parent, c.description, c.mot_cle, c.titre, c.statut as Active
					FROM t_category_path AS cp JOIN t_category AS c
					  ON cp.id = c.id_parent where c.statut = 1 and c.niveau <= " . $niveauMax . "
				)
				SELECT * FROM t_category_path
				ORDER BY nom";

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllCategoryParents($categ){
        $sql="select sQuery.idList as parentsList from (SELECT 1 as fakeId, GROUP_CONCAT(T2.id) as idList
                FROM (
                    SELECT
                        @r AS _id,
                        (SELECT @r := id_parent FROM t_category WHERE id = _id and statut = 1) AS id_parent,
                        @l := @l + 1 AS lvl
                    FROM
                        (SELECT @r := " . $categ . ", @l := 0) vars,
                        t_category m
                    WHERE @r <> 0 and m.statut = 1) T1
                JOIN t_category T2
                ON T1._id = T2.id
                GROUP BY fakeId) as sQuery";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllCategoryChilds($categ){
            $sql="SELECT *
                FROM t_category
                WHERE id_parent = " . $categ . "
                UNION
                SELECT * 
                FROM t_category
                WHERE id_parent IN 
                    (SELECT id FROM t_category WHERE id_parent = " . $categ . ") and statut = 1";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllCategories($parentId)
    {
        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_category where (id_parent = 0 or id_parent is null) and statut=1 order by nom ASC";

        $results = DB::select( DB::raw($sql) );

        $all = array();
        $categ = array();

        foreach ( $results as $result ){
            $sql2 = "select id, id_parent, nom, niveau, statut, date_insert from t_category where statut = 1 and id_parent = " . $result->id;
            $results2 = DB::select( DB::raw($sql2) );
            array_push($all,array("parent" => $result, "child" => $results2));
        }

        return $all;
    }

    public function getAllSousCategories($parentId)
    {
        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_category where id_parent = " . $parentId . " and statut=1";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getSingleCategDetail($idCateg)
    {
        $sql = "select id, id_parent, nom, niveau, statut, date_insert, description, titre, mot_cle  from t_category where id = " . $idCateg;

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    private function checkIfHasNiveau1($categId){
        $sqlNiveau1Child = "select count(id) as nb from t_category where id_parent = " . $categId . " and niveau = 1 and statut = 1";
        $niveau1ChildCount = DB::select( DB::raw($sqlNiveau1Child) );
        if ($niveau1ChildCount[0]->nb > 0) return true;
        else return false;
    }

    private function getChildNiveauByParent($parentId){
        $niveauEnfant = 0;
        if ($parentId && $parentId != 0){
            $niveauEnfant = 2;
            $sqlGetParentNiveau = "select niveau from t_category where id = " . $parentId . " and statut = 1";
            $resultsParentNiveau = DB::select( DB::raw($sqlGetParentNiveau) );
            $niveauParent = $resultsParentNiveau[0]->niveau;

            if ($niveauParent == 0 && $this->checkIfHasNiveau1($parentId) == true) $niveauEnfant = 1;
        }
       return $niveauEnfant;
    }

    public function addEditCategory(Request $request)
    {

        //Accept : application/json
        //Content-Type: application/json

        $id = $request->input('id');
        $id_parent = $request->input('id_parent');
        $name = $request->input('name');
        $description = $request->input('description');
        $titre = $request->input('titre');
        $motCle = $request->input('motCle');
        $slug = $this->SharedController->formatToSlug($name);

        $niveau = $this->getChildNiveauByParent($id_parent);

        $data = [
                    'nom' => $name,
                    'description' => $description,
                    'titre' => $titre,
                    'mot_cle' => $motCle,
                    'niveau' => $niveau,
                    'slug' => $slug
        ];

        if (isset($id_parent) && $id_parent != 0) $data['id_parent'] = $id_parent;
        
        if ($id != 0){
            $results = DB::table('t_category')->where('id', '=', (int)$id)->update($data);
        } else {
            DB::table('t_category')->insert($data);
            $id = DB::getPdo()->lastInsertId();
            
            $this->SharedController->addSEO(2, $id, $name, $slug);
        }
        return $this->getAdminCategories(2);
    }

    public function removeCategory(Request $request)
    {

        //Accept : application/json
        //Content-Type: application/json

        $id = $request->input('id');

        /*DB::table('t_category')->delete([
            'id' => $id
        ]);*/

        $results = DB::table('t_category')->where(['id' => $id])->update([
            'statut' => 0
        ]);

        $id = DB::getPdo()->lastInsertId();

        return $this->getAdminCategories(2);
    }

    public function categoriesList($p){
        $sql = "SELECT UPPER(SUBSTRING(nom, 1, 1)) as initial, CONCAT('[', GROUP_CONCAT('[',id, ',\"',concat(UPPER(SUBSTRING(nom, 1, 1)), SUBSTRING(nom, 2, (LENGTH(nom)-1))),'\"', ',\"', slug, '\"]'), ']') as categories FROM `t_category` WHERE `niveau` = 0 and statut = 1 GROUP by initial order by `initial` asc";
        //$sql = "SELECT id, UPPER(SUBSTRING(nom, 1, 1)) as initial, concat(UPPER(SUBSTRING(nom, 1, 1)), SUBSTRING(nom, 2, (LENGTH(nom)-1))) as nom FROM `t_category` WHERE `niveau` = 0 order by `nom` asc";
        $results = DB::select( DB::raw($sql) );



        return array_map(function($d){
            $d->categories = json_decode($d->categories, true);
            return $d;
        },$results);

        return $results;
    }

    public function getCatScatByName($categNom, $sCatNom)
    {
        $or = "";
        
        if ($sCatNom !== 0) $or = " or nom = '" . strtolower($sCatNom) . "'"; 

        $sql = "select * from t_category where statut = 1 and nom = '" . strtolower($categNom) . "'" . $or . "";
        
        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    private function getIdBySlug($slug, $parentSlug = ""){
        $sqlParent = "";
        if ($parentSlug != "")  $sqlParent = " and id_parent = (select c.id from t_category c where c.slug = '" . $parentSlug . "' limit 1) ";
        else $sqlParent = " and id_parent is null ";
        $sql = "select id from t_category where slug = '" . $slug . "' " . $sqlParent . " limit 1";
        $result = DB::select( DB::raw($sql));
        if (count($result) > 0) return $result[0]->id;
        else return 0;
        
    }

    public function getCategoriesByNiveau($categSlug, $niveau1 = "", $niveau2 = "")
    {
        $results = [];

        $sqlNiveau0 = "select * from t_category where slug = '" . $categSlug . "' and statut = 1 limit 1";
        $results0 = DB::select( DB::raw($sqlNiveau0));

        $niv0Id = (count($results0) > 0) ? $results0[0]->id : 0;

        // si le slug n'existe pas alors il faut arreter car erreur
        if ($niv0Id == 0) {
            //return redirect()->away(env('APP_404_URL'));
            return [];
        }

        //get niveau 1 details
        $sqlNiveau1 = "SELECT * FROM `t_category` WHERE statut = 1 and id_parent = " . $results0[0]->id;
        $results1 = DB::select( DB::raw($sqlNiveau1));
        
        //get niveau 2 details
        // si niveau 1, on prend les sous-niveau 2
        $sqlNiveau2 = "";
        if (count($results1) > 0 && $results1[0]->niveau == 1 && $niveau1 != ""){
            $sqlNiveau2 = "SELECT * FROM `t_category` WHERE id_parent = (select t.id from t_category t where t.slug='" . $niveau1 . "' and statut = 1 limit 1) and statut = 1";
        } else if (count($results1) > 0) {
            $sqlNiveau2 = "SELECT * FROM `t_category` WHERE statut = 1 and id_parent = " . $results1[0]->id;
        }
        $results2 = [];

        if ($sqlNiveau2) $results2 = DB::select( DB::raw($sqlNiveau2));

        if ($niveau2 != "") {
            $n1 = ($niveau1 != "") ? $niveau1 : "";
            if ($this->getIdBySlug($niveau2, $n1) == 0) return [];
            $allArticles = $this->getAllArticles($this->getIdBySlug($niveau2, $n1), 1);
            $this->SharedController->setCounter(1, 0, $this->getIdBySlug($niveau2, $n1));
        }

        else if ($niveau1 != "") {
            $n2 = ($categSlug != "") ? $categSlug : "";
            if ($this->getIdBySlug($niveau1, $n2) == 0) return [];
            $allArticles = $this->getAllArticles($this->getIdBySlug($niveau1, $n2), 1);
            $this->SharedController->setCounter(1, 0, $this->getIdBySlug($niveau1, $n2));
        }

        else {
            $allArticles = $this->getAllArticles($this->getIdBySlug($categSlug), 1);
            if ($niv0Id != 0) $this->SharedController->setCounter(1, 0, $niv0Id);
        }

        $results["niveau0"] = $results0;
        $results["niveau1"] = $results1;
        $results["niveau2"] = $results2;
        $results["articles"] = $allArticles;
        
        return $results;
    }

    public function getAllChildCategories($categId, $includeMe, $niveau = 0){
        $niveauSQL = ($niveau == 0) ? "" : " where tout.niveau = " . $niveau;
        $sql = "select * from (select id, nom, titre, niveau
        from    (select * from t_category where statut = 1
                 order by id_parent, id) tablename,
                (select @pv := '" . $categId . "') initialisation
        where   find_in_set(id_parent, @pv) > 0
        and     @pv := concat(@pv, ',', id)) tout " . $niveauSQL;

        $results = DB::select( DB::raw($sql) );

        $rs = [];

        if ($includeMe == 1){
            $sql2 = "select id, nom from t_category where statut = 1 and id = " . $categId;

            $results2 = DB::select( DB::raw($sql2) );

            $rs = array_merge($results2, $results);
        } else {
            $rs =  $results;
        }

        return $rs;

    }

    public function getAllArticles($categId, $includeMe)
    {
        $all = [];

        $allcateg = $this->getAllChildCategories($categId, $includeMe, 0);

        foreach ($allcateg as $categ){

            $sql = "SELECT a.id, a.titre, a.lien_web, a.image, a.sous_titre, a.description, a.email, a.adresse, a.tel, a.fax, a.ouverture, a.itineraire, a.nom_personne, a.societe, a.descr_gratuit, a.lien_resto1, a.lien_resto2, a.lien_resto3, a.lien_resto4, a.lien_clickcollect, coalesce(a.url, '') as url, a.payant, a.reduction, a.bon, a.categ_resto, a.statut, a.date_insert, a.tmp, a.slug, GROUP_CONCAT(CONCAT(i.id, ',', REPLACE(i.image, '\'', '\'\''), ',', REPLACE(i.legende, '\'', '\'\''), ',', REPLACE(i.titre, '\'', '\'\''), ',', REPLACE(i.alternatif, '\'', '\'\'')) separator '|') as icones
            FROM 
                t_art_categ ac
                LEFT JOIN t_article a on ac.id_article = a.id
                LEFT JOIN t_encadre_icone ei on a.id = ei.id_encadre
                LEFT JOIN t_icone i on ei.id_icone = i.id
            WHERE ac.id_category = " . $categ->id . "
            and a.statut <> 0
            GROUP BY a.id, a.titre
            ORDER BY rand()
            ";
            $results = DB::select( DB::raw($sql) );
            $all = array_merge($all, $results);
        }

        //$all = array_unique($all, SORT_REGULAR);

        $allUniq = array();
        
        $ids = array();

        foreach ($all as $single) {
            if ( ! in_array($single->id, $ids)) {
                $allUniq[] = $single;
            }
            array_push($ids, $single->id);
        }

        $allUniq = $this->resetImageInArray($allUniq);

        $allUniq = $this->resetImageCarousel($allUniq);

        shuffle($allUniq);

        return $allUniq;
    }

    public function resetImageInArray($results){
        //return pathinfo('../');
        $fileRoot = public_path() . '/article/';
        //echo $fileRoot;
        foreach ($results as $result){
            $filename = $fileRoot . $result->image;
            if (!file_exists($filename)) $result->image = 'default.jpg';
        }

        return $results;
    }

    public function resetImageCarousel($results){

        foreach ($results as $result){
			if (isset($result->id) && $result->id != 0){
				$sql = "select * from t_carousel where id_article = " . $result->id ;
				$rs = DB::select( DB::raw($sql) );
				$result->carousel = $rs;
			} else {
				$result->carousel = [];
			}
            
        }

        return $results;
    }

    public function getBCName($categSlug, $niveau1 = "", $niveau2 = "")
    {
        $results = [];
        $sql1 = "select slug, nom as name, id from t_category where slug = '" . $categSlug . "' limit 1";
        $result1 = DB::select( DB::raw($sql1));
        array_push($results, $result1);

        if ($niveau1 != ""){
            $sql2 = "select slug, nom as name, id from t_category where slug = '" . $niveau1 . "' and id_parent = " . $result1[0]->id . " limit 1";
            $result2 = DB::select( DB::raw($sql2));
            array_push($results, $result2);
        }

        if ($niveau2 != "" && count($result2) > 0){
            $sql3 = "select slug, nom as name, id from t_category where slug = '" . $niveau2 . "' and id_parent = " . $result2[0]->id . " limit 1";
            $result3 = DB::select( DB::raw($sql3));
            array_push($results, $result3);
        }

        return $results;
    }
    
    public function checkCategory($slug){

        $id = 0;
        
        $retour = (array)DB::table('t_category')->select('id')->where([
            ["slug", "=", $slug]
        ])->first();
        
        return count($retour);
    }

}
