<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
//use Illuminate\Support\Facades\Request;
use DB;

class AnnonceController extends Controller
{
    /**
     * Handle the incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function __invoke(Request $request)
    {
        //
    }

    public function wLogs($data)
    {
        $logPath = "logs.txt";
        $mode = (!file_exists($logPath)) ? 'w':'a';
        $logfile = fopen($logPath, $mode);
        fwrite($logfile, "\r\n". $data);
        fclose($logfile);
    }

    public function getAnnonceCategories($parentId)
    {
        $where = ($parentId != -1) ? " and id_parent = " . $parentId : "";

        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_annonce_category where statut=1 " . $where;

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAdminAnnonceCategories($parentId)
    {
        $sql = "select t1.id, t1.nom, t1.titre,  t1.id_parent, t2.nom as parent, t1.description, t1.mot_cle, t1.statut as Active from t_annonce_category t1
        inner join t_annonce_category t2 on t1.id_parent = t2.id where t1.statut=1";

        //$this->wLogs(json_encode($sql));

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAllAnnonceCategories($parentId)
    {
        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_annonce_category where (id_parent = 0 or id_parent is null) and statut=1";

        $results = DB::select( DB::raw($sql) );

        $all = array();
        $categ = array();

        foreach ( $results as $result ){
            $sql2 = "select id, id_parent, nom, niveau, statut, date_insert from t_annonce_category where id_parent = " . $result->id;
            $results2 = DB::select( DB::raw($sql2) );
            array_push($all,array("parent" => $result, "child" => $results2));
        }

        return $all;
    }

    public function getAllAnnonceSousCategories($parentId)
    {
        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_annonce_category where id_parent = " . $parentId . " and statut=1";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getSingleAnnonceCategDetail($idCateg)
    {
        $sql = "select id, id_parent, nom, niveau, statut, date_insert from t_annonce_category where id = " . $idCateg;

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function addCategory(Request $request)
    {

        //Accept : application/json
        //Content-Type: application/json

        $id_parent = $request->input('id_parent');
        $name = $request->input('name');
        $description = $request->input('description');
        $titre = $request->input('titre');
        $motCle = $request->input('motCle');
        
        DB::table('t_annonce_category')->insert([
            'id_parent' => $id_parent,
            'nom' => $name,
            'description' => $description,
            'titre' => $titre,
            'mot_cle' => $motCle
        ]);

        $id = DB::getPdo()->lastInsertId();

        return $this->getAdminAnnonceCategories(0);
    }

    public function removeCategory(Request $request)
    {

        //Accept : application/json
        //Content-Type: application/json

        $id = $request->input('id');

        DB::table('t_annonce_category')->delete([
            'id' => $id
        ]);

        $id = DB::getPdo()->lastInsertId();

        return $this->getAdminAnnonceCategories(0);
    }


    public function getAllAnnonces($categId, $includeMe)
    {
        /*$where = ($categId == -1) ? "" : "where id_category = " . $categId;

        $sql = "select * from t_article " . $where;*/

        //$sql = "";
        $all = [];

        $allcateg = $this->getAllChildCategories($categId, $includeMe);

        foreach ($allcateg as $categ){
            /*$sql = "select a.* 
                    from 
                        t_art_categ ac
                        inner join t_article a on ac.id_article = a.id
                        where ac.id_category = " . $categ->id;*/

            $sql = "SELECT a.*
            FROM 
                t_annonce_categ ac
                LEFT JOIN t_annonce a on ac.id_annonce = a.id
            WHERE ac.id_category = " . $categ->id . "
            GROUP BY a.id
            ";
            $results = DB::select( DB::raw($sql) );
            $all = array_merge($all, $results);
        }

        /*$all = $this->resetImageInArray($all);

        $all = $this->resetImageCarousel($all);*/

        return $all;
    }

    public function getAllChildCategories($categId, $includeMe){
        $sql = "select id, nom
        from    (select * from t_annonce_category
                 order by id_parent, id) tablename,
                (select @pv := '" . $categId . "') initialisation
        where   find_in_set(id_parent, @pv) > 0
        and     @pv := concat(@pv, ',', id)";

        $results = DB::select( DB::raw($sql) );

        $rs = [];

        if ($includeMe == 1){
            $sql2 = "select id, nom from t_annonce_category where id = " . $categId;

            $results2 = DB::select( DB::raw($sql2) );

            $rs = array_merge($results2, $results);
        } else {
            $rs =  $results;
        }

        return $rs;

    }


    public function getAnnonce($idAnnonce){
        $sql = "SELECT 
                    a.*, 
                    u.first_name, u.last_name, u.email,
                    l.ville, l.pays
                FROM 
                    t_annonce a 
                    INNER JOIN users u on a.id_user = u.id
                    LEFT JOIN t_localite l on a.id_localite = l.id
                WHERE 
                    a.id = " . $idAnnonce;

        $results = DB::select( DB::raw($sql) );

        return $results;

    }

}
